package internal.la;

import jade.core.behaviours.OneShotBehaviour;

// processes messages received from WA
public class PreOrderBehaviour extends OneShotBehaviour {
	IssueOrderBehaviour theMaster;

	public PreOrderBehaviour(IssueOrderBehaviour master) {
		theMaster = master;
	}

	public void action() {
		// add new behaviour to allow LA to process several orders at the
		// same time
		theMaster.theAgent.addBehaviour(new IssueOrderBehaviour(
				theMaster.theAgent));
		// retrieve received message
		theMaster.orderRequestMessage = theMaster
				.retrieveData(IssueOrderBehaviour.ORDER_REQUEST_MSG);
		// extract necessary data from the message
		theMaster.theOrder = LAHelper.extractOrderDescription(myAgent,
				theMaster.orderRequestMessage);
		theMaster.theDeadline = theMaster.theOrder.getDeliveryTimeRequired();
	}
}
